<?php
// API doc : http://techbureau-api-document.readthedocs.io/ja/latest/trade/2_individual/1_get_info.html

// zaif trade api url
$zaif_api_url  = "https://api.zaif.jp/tapi";
// api method name
$method = "get_info";

// Please set API_KEY and API_SECRET_KEY
$API_KEY = ""; 
$API_SECRET_KEY = ""; 

// proxy settings
$proxy      = "";
$proxy_port = "";

$nonce = time();
$body = http_build_query(
    array(
        "nonce"=>$nonce,
        "method"=>$method
    )
);
$signature = hash_hmac("sha512", $body, $API_SECRET_KEY);
$headers = array(
    "Sign: {$signature}",
    "Key: {$API_KEY}"
);

$curl = curl_init();
if ($curl == FALSE) {
    fputs(STDERR, "[ERR] curl_init(): " . curl_error($curl) . PHP_EOL);
    die(1);
}

// curl set options
curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
// set proxy server settings
if (!empty($proxy) && !empty($proxy_port)) {
    curl_setopt($curl, CURLOPT_HTTPPROXYTUNNEL, 1);
    curl_setopt($curl, CURLOPT_PROXY, $proxy . ":" . $proxy_port);
    curl_setopt($curl, CURLOPT_PROXYPORT, $proxy_port);
}

curl_setopt($curl, CURLOPT_URL, $zaif_api_url);
curl_setopt($curl, CURLOPT_POST, TRUE);
curl_setopt($curl, CURLOPT_POSTFIELDS, $body);
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

$response = curl_exec($curl);
if ($response == FALSE) {
    fputs(STDERR, "[ERR] curl_exec(): " . curl_error($curl) . PHP_EOL);
    die(1);
}

// json decode
$json_decode = json_decode($response, true);
if ($json_decode == NULL) {
    fputs(STDERR, "[ERR] json_decode(): " . json_last_error_msg() . PHP_EOL);
    die(1);
}

curl_close($curl);

//print_r($json_decode);
if (!$json_decode["success"]) {
    fputs(STDERR, "[ERR] " . $json_decode["error"] . PHP_EOL);
    die(1);
}

// funds key sort array
$funds = $json_decode["return"]["funds"];
ksort($funds);
// deposit key sort array
$deposit = $json_decode["return"]["deposit"];
ksort($deposit);

print("-------- Funds --------" . PHP_EOL);
foreach ($funds as $key => $val) {
    printf("%10s\t%f" . PHP_EOL, $key, $val);
}
print("-------- Deposit --------" . PHP_EOL);
foreach ($deposit as $key => $val) {
    printf("%10s\t%f" . PHP_EOL, $key, $val);
}

exit(0);
